// TsDescriptor.h: Lqqbp[NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_TSDESCRIPTOR_H_)
#define _TSDESCRIPTOR_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MediaData.h"


/////////////////////////////////////////////////////////////////////////////
// Lqq̊NX
/////////////////////////////////////////////////////////////////////////////

class CBaseDesc
{
public:
	CBaseDesc();
	CBaseDesc(const CBaseDesc &Operand);

	CBaseDesc & operator = (const CBaseDesc &Operand);

	virtual const bool ParseDesc(const BYTE *pHexData, const BYTE byDataLength) = 0;

	virtual const bool IsValid(void) const;
	virtual const BYTE GetTag(void) const;
	virtual const BYTE GetLen(void) const;

	virtual void Reset(void);

protected:
	BYTE m_byDescTag;	// Lqq^O
	BYTE m_byDescLen;	// Lqq
	bool m_bIsValid;	// ͌
};


/////////////////////////////////////////////////////////////////////////////
// [0x09] Conditional Access Method LqqۉNX
/////////////////////////////////////////////////////////////////////////////

class CCaMethodDesc : public CBaseDesc
{
public:
	CCaMethodDesc();
	CCaMethodDesc(const CCaMethodDesc &Operand);

	CCaMethodDesc & operator = (const CCaMethodDesc &Operand);

// CBaseDesc
	virtual const bool ParseDesc(const BYTE *pHexData, const BYTE byDataLength);
	virtual void Reset(void);

// CCaMethodDesc
	const WORD GetCaMethodID(void) const;
	const WORD GetCaPID(void) const;
	const CMediaData * GetPrivateData(void) const;

protected:
	WORD m_wCaMethodID;			// Conditional Access Method ID
	WORD m_wCaPID;				// Conditional Access PID
	CMediaData m_PrivateData;	// Private Data
};


/////////////////////////////////////////////////////////////////////////////
// [0x52] Stream Identifier LqqۉNX
/////////////////////////////////////////////////////////////////////////////

class CStreamIdDesc : public CBaseDesc
{
public:
	CStreamIdDesc();
	CStreamIdDesc(const CStreamIdDesc &Operand);

	CStreamIdDesc & operator = (const CStreamIdDesc &Operand);

// CBaseDesc
	virtual const bool ParseDesc(const BYTE *pHexData, const BYTE byDataLength);
	virtual void Reset(void);

// CStreamIdDesc
	const BYTE GetComponentTag(void) const;

protected:
	BYTE m_byComponentTag;		// Component Tag
};


#endif // !defined(_TSDESCRIPTOR_H_)
